routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\CompanieController;
use App\Http\Controllers\EmployeeController;
use App\Http\Controllers\Auth\SocialiteController;
use App\Http\Controllers\ItemController;
use App\Http\Controllers\SellController;
use App\Http\Controllers\SellSummaryController;
use App\Jobs\SendEmailJob;
use Illuminate\Support\Facades\Auth;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/


Auth::routes([
    'register' => false
]);

Route::get('/auth/redirect/{provider}',[SocialiteController::class,'redirect'])->name('auth.redirect');
Route::get('/auth/callback/{provider}',[SocialiteController::class,'callback'])->name('auth.callback');

Route::middleware('auth')->group(function(){
    
    Route::get('lang/{lang}', ['as' => 'lang.switch', 'uses' => App\Http\Controllers\LanguageController::class,'switch']);

    Route::get('/', function () {
        return view('home');
    });

    Route::get('tz/{tz}', ['as' => 'tz.switch', 'uses' => App\Http\Controllers\TimezoneController::class,'switch']);

    Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

    Route::resource('employees',EmployeeController::class)->except(['destroy']);
    Route::resource('sells',SellController::class)->except(['destroy']);
    Route::get('/employees/{employee}/destroy',[EmployeeController::class,'destroy'])->name('employees.destroy');
    
    Route::resource('companies',CompanieController::class)->except(['destroy']);
    Route::resource('items',ItemController::class)->except(['destroy']);
    Route::resource('sellSummaries',SellSummaryController::class)->except(['destroy']);
    Route::get('/items/{item}/destroy',[ItemController::class,'destroy'])->name('items.destroy');
    Route::get('/sells/{sell}/destroy',[SellController::class,'destroy'])->name('sells.destroy');

    Route::get('/companies/{company}/destroy',[CompanieController::class,'destroy'])->name('companies.destroy');
    
    Route::get('test/email', function(){
        $send_mail = 'lim.liete@gmail.com';
        dispatch(new App\Jobs\SendEmailJob($send_mail));
        dd('send mail successfully !!');
    })->name('sendEmail');
    

    

});

app/Models/Sell.php
<?php

namespace App\Models;

use App\Models\Employee;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use App\Models\Item;

class Sell extends Model
{
    use HasFactory;

    protected $fillable = [
        'date',
        'item_id',
        'price',
        'discount',
        'employee_id'
    ];
    public $timestamps = false;
    public function employee(){
        return $this->belongsTo(Employee::class);
    }

    public function item(){
        return $this->belongsTo(Item::class);
    }
    
}

app/Http/Controllers/SellController.php
<?php

namespace App\Http\Controllers;

use App\Models\Companie;
use App\Models\Employee;
use Illuminate\Http\Request;
use App\Http\Requests\EmployeeStoreRequest;
use App\Http\Requests\SellStoreRequest;
use App\Models\Item;
use App\Models\Sell;
use App\Models\SellSummary;
use App\Models\Summary;
use Illuminate\Support\Facades\App;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Carbon;

class SellController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $employees = Employee::select('id', 'first_name')->latest()->get();
        $items = Item::select('id', 'name', 'price')->get();
        // $employees = Employee::latest()->paginate(10);
        // return view('employee.index',compact('employees'));
        return view('sell.index',compact('employees','items'));
    }



    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $employees = Employee::select('id', 'first_name')->latest()->get();
        $items = Item::select('id', 'name', 'price')->latest()->get();
        return view('sell.create', compact('employees', 'items'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(SellStoreRequest $request)
    {
        Sell::create([
            'date' => $request->date,
            'item_id' => $request->item_id,
            'price' => $request->price,
            'discount' => $request->discount,
            'employee_id' => $request->employee_id
        ]);

        $summary = SellSummary::where('date', '=', Carbon::parse($request->date)->format('Y-m-d'))->where('employee_id', '=', $request->employee_id)->first();
        $getPriceTotal = empty($summary)? 0 : $summary->price_total;
        $finalPriceTotal = $getPriceTotal + $request->price;
        $getDiscountTotal = empty($summary)? 0 : $summary->discount_total;
        $finalDiscountTotal = $getDiscountTotal + ($request->price * $request->discount / 100);
        $total = $finalPriceTotal - $finalDiscountTotal;
        SellSummary::updateOrCreate(
            ['date' => Carbon::parse($request->date)->format('Y-m-d'), 'employee_id' => $request->employee_id],
            [
                'price_total' => $finalPriceTotal,
                'discount_total' => $finalDiscountTotal,
                'total' => $total
            ]
        );

        return redirect()->route('sells.create')->with('message', ['text' => __('sell.status2'), 'class' => 'success']);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit(Sell $sell)
    {
        $employees = Employee::select('id', 'first_name')->get();
        $items = Item::select('id', 'name', 'price')->get();
        return view('sell.edit', compact('sell', 'employees', 'items'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(SellStoreRequest $request, Sell $sell)
    {
        $sell->update([
            'date' => $request->date,
            'item_id' => $request->item_id,
            'price' => $request->price,
            'discount' => $request->discount,
            'employee_id' => $request->employee_id
        ]);

        return redirect()->route('sells.edit', $sell->id)->with('message', ['text' => __('sell.status3'), 'class' => 'success']);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy(Sell $sell)
    {
        $sell->delete();
        return redirect()->route('sells.index')->with('message', ['text' => __('sell.status4'), 'class' => 'success']);
    }
}

resources/views/sell/create.blade.php
@extends('layouts.app')
@section('title')
{{trans('sell.title2') }}
@endsection
@section('content')
<div class="container">
    <div class="row justify-content-center">

        @include('layouts.notif')

        <div class="col-md-12 mt-2">
            <div class="card">
                <div class="card-header">
                {{trans('sell.title2') }}
                    <a href="{{ route('sells.index') }}" class="btn btn-sm btn-secondary float-right">{{trans('sell.btn4') }}</a>
                </div>
                <div class="card-body">
                    <form action="{{ route('sells.store')}}" method="POST">
                        @csrf
                        <div class="row" style="display: none;">
                            <div class="col-6">
                                <label for="">Date</label>
                                <input type="text" class="form-control" name="date" value="{{ Carbon\Carbon::now()->toDateTimeString()}}">
                                @include('layouts.error', ['name' => 'date'])
                            </div>
                        </div>
                        
                            <div class="row mt-3">
                                <div class="col-md-12  item-select">
                                    <label for="">{{trans('sell.table2') }}</label>
                                    <select name="item_id" class="form-control">
                                        <option value="" selected disabled>{{trans('sell.optionitem') }}</option>
                                        @forelse ($items as $item)
                                        <option data-price="{{ $item->price }}" value="{{ $item->id }}">{{ $item->name }}</option>
                                        @empty
                                        <option value="" selected>{{trans('sell.status1') }}</option>
                                        @endforelse
                                    </select>
                                    @include('layouts.error', ['name' => 'item_id'])
                                </div>
                            </div>
                            <div class="row mt-3">
                                <div class="col-6 ">
                                    <label for="">{{trans('sell.table3') }}</label>
                                    <input type="number" class="form-control price-input" name="price" value="{{ old('price')}}" readonly>
                                    @include('layouts.error', ['name' => 'price'])
                                </div>
                                <div class="col-6">
                                    <label for="">{{trans('sell.table4') }}</label>
                                    <input type="number" class="form-control" name="discount" value="{{ old('discount')}}">
                                    @include('layouts.error', ['name' => 'discount'])
                                </div>
                            </div>
                        
                        <div class="row mt-3">
                            <div class="col-md-12">
                                <label for="">{{trans('sell.table5') }}</label>
                                <select name="employee_id" class="form-control">
                                    <option value="" selected disabled>{{trans('sell.optionemployee') }}</option>
                                    @forelse ($employees as $employee)
                                    <option value="{{ $employee->id }}">{{ $employee->first_name }}</option>
                                    @empty
                                    <option value="" selected>{{trans('sell.status1') }}</option>
                                    @endforelse
                                </select>
                                @include('layouts.error', ['name' => 'employee_id'])
                            </div>
                        </div>
                        <div class="row p-3">
                            <button class="btn btn-primary btn-block" type="submit">{{trans('sell.btn1') }}</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection
@section('script')
<script src="https://ajax.googleapis.com/ajax/libs/jquery/2.1.1/jquery.min.js"></script>
<script>
    $('.item-select').on('change', function() {
        $('.price-input')
            .val(
                $(this).find(':selected').data('price')
            );
    });
</script>
@endsection

resources/views/sell/edit.blade.php
@extends('layouts.app')
@section('title')
    {{ trans('sell.title3') }}
@endsection
@section('content')
    <div class="container">
        <div class="row justify-content-center">

            @include('layouts.notif')

            <div class="col-md-12 mt-2">
                <div class="card">
                    <div class="card-header">
                        {{ trans('sell.title3') }}
                        <a href="{{ route('sells.index') }}" class="btn btn-sm btn-secondary float-right">
                            {{ trans('sell.btn4') }}</a>
                    </div>
                    <div class="card-body">
                        <form action="{{ route('sells.update', $sell->id) }}" method="POST">
                            @csrf
                            @method('PUT')
                            <div class="row" style="display: none;">
                                <div class="col-6">
                                    <label for="">Date</label>
                                    <input type="text" class="form-control" name="date"
                                        value="{{ Carbon\Carbon::now()->toDateTimeString() }}">
                                    @include('layouts.error', ['name' => 'date'])
                                </div>
                            </div>
                            <div class="row mt-3">
                                <div class="col-md-12 item-select">
                                    <label for="">{{ trans('sell.table2') }}</label>
                                    <select name="item_id" class="form-control">
                                        <option value="" selected disabled>{{ trans('sell.optionitem') }}</option>
                                        @forelse ($items as $item)
                                            @php
                                                if ($item->id == $sell->item_id) {
                                                    $select = 'selected';
                                                } else {
                                                    $select = '';
                                                }
                                                echo "<option $select data-price='$item->price' value='$item->id'>" . $item['name'] . '</option>';
                                            @endphp
                                        @empty
                                            <option value="" selected> {{ trans('sell.status1') }}</option>
                                        @endforelse
                                    </select>
                                    @include('layouts.error', ['name' => 'item_id'])
                                </div>
                            </div>
                            <div class="row mt-3">
                                <div class="col-6">
                                    <label for="">{{ trans('sell.table3') }}</label>
                                    <input type="number" class="form-control price-input" name="price"
                                        value="{{ $sell->price }}" readonly>
                                    @include('layouts.error', ['name' => 'price'])
                                </div>
                                <div class="col-6">
                                    <label for="">{{ trans('sell.table4') }}</label>
                                    <input type="number" class="form-control" name="discount"
                                        value="{{ $sell->discount }}">
                                    @include('layouts.error', ['name' => 'discount'])
                                </div>
                            </div>
                            <div class="row mt-3">
                                <div class="col-md-12">
                                    <label for="">{{ trans('sell.table5') }}</label>
                                    <select name="employee_id" class="form-control">
                                        <option value="" selected disabled>{{ trans('sell.optionemployee') }}</option>
                                        @forelse ($employees as $employee)
                                            @php
                                                if ($employee->id == $sell->employee_id) {
                                                    $select = 'selected';
                                                } else {
                                                    $select = '';
                                                }
                                                echo "<option $select value='$employee->id'>" . $employee['first_name'] . '</option>';
                                            @endphp
                                        @empty
                                            <option value="" selected> {{ trans('sell.status1') }}</option>
                                        @endforelse
                                    </select>
                                    @include('layouts.error', ['name' => 'employee_id'])
                                </div>
                            </div>
                            <div class="row p-3">
                                <button class="btn btn-primary btn-block" type="submit">{{ trans('sell.btn5') }}</button>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection
@section('script')
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/2.1.1/jquery.min.js"></script>
    <script>
        $('.item-select').on('change', function() {
            $('.price-input')
                .val(
                    $(this).find(':selected').data('price')
                );
        });
    </script>
@endsection

resources/views/sell/index.blade.php
@extends('layouts.app')
@section('title')
    {{ trans('sell.title1') }}
@endsection
@section('content')
    <div class="container">
        <div class="row justify-content-center">

            @include('layouts.notif')

            <div class="col-md-12 mt-2">
                <div class="card">
                    <div class="card-header">
                        {{ trans('sell.title1') }}
                        <a href="{{ route('sells.create') }}"
                            class="btn btn-sm btn-primary float-right">{{ trans('sell.btn1') }}</a>
                    </div>
                    <div class="card-body">
                        <br>
                        <!-- MULAI DATE RANGE PICKER -->
                        <div class="row input-daterange">
                            <div class="col-md-6">
                                <input type="text" name="from_date" id="from_date" class="form-control"
                                    placeholder="{{ trans('sell.fromdate') }}" readonly />
                            </div>
                            <div class="col-md-6">
                                <input type="text" name="to_date" id="to_date" class="form-control"
                                    placeholder="{{ trans('sell.todate') }}" readonly />
                            </div>
                        </div>
                        <!-- AKHIR DATE RANGE PICKER -->
                        <br>
                        <div class="row">
                            <div class="col-md-6  companie-select">
                                <select name="item_id" id="item_id" class="form-control">
                                    <option value="">Select Item</option>
                                    @forelse ($items as $item)
                                        <option value="{{ $item->id }}">{{ $item->name }}</option>
                                    @empty
                                        <option value="" selected>{{ trans('sell.status1') }}</option>
                                    @endforelse
                                </select>
                                @include('layouts.error', ['name' => 'item_id'])
                            </div>
                            <div class="col-md-6  companie-select">
                                <select name="employee_id" id="employee_id" class="form-control">
                                    <option value="">Select Employee</option>
                                    @forelse ($employees as $employee)
                                        <option value="{{ $employee->id }}">{{ $employee->first_name }}</option>
                                    @empty
                                        <option value="" selected>{{ trans('sell.status1') }}</option>
                                    @endforelse
                                </select>
                                @include('layouts.error', ['name' => 'item_id'])
                            </div>
                        </div>
                        <br>
                        <div class="row">
                            <div class="col-md" style="text-align: end">
                                <button type="button" name="filter" id="filter"
                                    class="btn btn-primary">{{ trans('sell.btn6') }}</button>
                                <button type="button" name="refresh" id="refresh"
                                    class="btn btn-default">{{ trans('sell.btn7') }}</button>
                            </div>
                        </div>
                        <br>
                        <table class="table text-center table-bordered table-striped" id="SellsTable">
                            <thead>
                                <tr>
                                    <th>#</th>
                                    <th>{{ trans('sell.table1') }}</th>
                                    <th>{{ trans('sell.table2') }}</th>
                                    <th>{{ trans('sell.table3') }}</th>
                                    <th>{{ trans('sell.table4') }}</th>
                                    <th>{{ trans('sell.table5') }}</th>
                                    <th>{{ trans('sell.table6') }}</th>
                                </tr>
                            </thead>
                            <tbody>
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

@section('script')
    <link rel="stylesheet"
        href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.8.0/css/bootstrap-datepicker.min.css">

    <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.8.0/js/bootstrap-datepicker.js"></script>
    <script type="text/javascript">
        $(document).ready(function() {
            $.noConflict();
            var table = $('#SellsTable').DataTable({
                "processing": true,
                "serverSide": true,
                "dom": "lrtpi",
                "responsive": true,
                ajax: {
                    url: "{{ route('api.sells') }}",
                    type: 'GET',
                    data: {
                        region: "{{ Session::get('tz') }}"
                    }
                },
                "columns": [{
                        "data": "DT_RowIndex",
                        name: 'DT_RowIndex'
                    },
                    {
                        "data": "date"
                    },
                    {
                        "data": "item.name"
                    },
                    {
                        "data": "price"
                    },
                    {
                        "data": "discount"
                    },
                    {
                        "data": "employee.first_name"
                    },
                    {
                        "data": "action",
                        name: 'action',
                        orderable: false,
                        searchable: false
                    }
                ]
            });
            // $('.filter-input').keyup(function() {
            //     table.column($(this).data('column'))
            //         .search($(this).val())
            //         .draw();
            // });
        });
    </script>
    <script>
        //jalankan function load_data diawal agar data ter-load
        // load_data();
        //Iniliasi datepicker pada class input
        $('.input-daterange').datepicker({
            todayBtn: 'linked',
            format: 'yyyy-mm-dd',
            autoclose: true
        });
        $('#filter').click(function() {
            var from_date = $('#from_date').val();
            var to_date = $('#to_date').val();
            var item_id = $('#item_id').val();
            var employee_id = $('#employee_id').val();
            if (from_date != '' && to_date != '') {
                $('#SellsTable').DataTable().destroy();
                load_data(from_date, to_date, item_id, employee_id);
            } else {
                $('#from_date').val('');
                $('#to_date').val('');
                $('#SellsTable').DataTable().destroy();
                load_data('', '', item_id, employee_id);
            }
        });
        $('#refresh').click(function() {
            $('#from_date').val('');
            $('#to_date').val('');
            $('#item_id').val('');
            $('#employee_id').val('');
            $('#SellsTable').DataTable().destroy();
            load_data();
        });



        function load_data(from_date = '', to_date = '', item_id = '', employee_id = '') {
            var table = $('#SellsTable').DataTable({
                "processing": true,
                "dom": "lrtpi",
                "serverSide": true,
                "responsive": true,
                ajax: {
                    url: "{{ route('api.sells') }}",
                    type: 'GET',
                    data: {
                        from_date: from_date,
                        to_date: to_date,
                        item_id: item_id,
                        employee_id: employee_id,
                        region: "{{ Session::get('tz') }}"
                    } //jangan lupa kirim parameter tanggal 
                },
                "columns": [{
                        "data": "DT_RowIndex",
                        name: 'DT_RowIndex'
                    },
                    {
                        "data": "date"
                    },
                    {
                        "data": "item.name"
                    },
                    {
                        "data": "price"
                    },
                    {
                        "data": "discount"
                    },
                    {
                        "data": "employee.first_name"
                    },
                    {
                        "data": "action",
                        name: 'action',
                        orderable: false,
                        searchable: false
                    }
                ]
            });
            // $('.filter-input').keyup(function() {
            //     table.column($(this).data('column'))
            //         .search($(this).val())
            //         .draw();
            // });
        };
    </script>
@endsection